function MyProfileController(ScreenService, templateManager, ACLUtilities, AclMessages, MyProfileService, LibUtilities) {
    
    /** This code allows the use of the 'debugger' keyword without jslint bothering  */
    /*jshint -W087 */

    /* *******************************************************
    ********************* Get Widgets ***********************
    **********************************************************/

    var getBasicInfoWidget = function () {
        return templateManager.container.getWidget('USER_INFO');
    };

    var getEditPasswordWidget = function () {
        return templateManager.container.getWidget('EDIT_PASSWORD');
    };
    

    /* *******************************************************
    ********************* Get Fields ***********************
    **********************************************************/


    /* *******************************************************
    ******************* USER_INFO  WIDGET ********************
    **********************************************************/

   /* ***************** Widget Events ******************** */

    this.userInfoWidgetAfterLoadDataSource = function () {
        var widget = getBasicInfoWidget();
        widget.moveToFirst();
        if(!widget.currentRow.IMAGE){
            widget.currentRow.IMAGE = './assets/images/user.jpg';
        }
    };

    /* ***************** Actions Events ******************** */
    
    this.basicInfoActionEventEdit = function () {
        var basicInfoWidget = getBasicInfoWidget();
        basicInfoWidget.edit();
        basicInfoWidget.template = basicInfoWidget.templateToForm;
        if(!basicInfoWidget.currentRow.HAS_IMAGE){
            basicInfoWidget.currentRow.IMAGE = '';
        }
    };
    
    this.basicInfoActionEventCancel = function () {
        var basicInfoWidget = getBasicInfoWidget();
        ACLUtilities.genericCancelEvent(basicInfoWidget);
        basicInfoWidget.template = basicInfoWidget.templateToView;
    };
    
    this.basicInfoActionEventOpenPasswordEdit = function () {
        ScreenService.openPopup(getEditPasswordWidget());
    };
    
    this.basicInfoActionEventSave = function () {
        var basicInfoWidget = getBasicInfoWidget();
        if (!basicInfoWidget.currentRow.IMAGE){
            basicInfoWidget.currentRow.changed = true;
            MyProfileService.deleteProfilePicture(basicInfoWidget.currentRow).then(function () {
                reloadAndSetTemplateViewWidget(basicInfoWidget);
            });
        } else {
            MyProfileService.uploadProfilePicture(basicInfoWidget.currentRow).then(function () {
                reloadAndSetTemplateViewWidget(basicInfoWidget);
            });
        }
    };

    var reloadAndSetTemplateViewWidget = function (widget) {
        widget.reload().then(function () {
            templateManager.userData.image = widget.currentRow.IMAGE;
            templateManager.updateTemplate();
            widget.template = widget.templateToView;
            widget.view();
        });
    };
    
    /* *******************************************************
    ***************** EDIT_PASSWORD  WIDGET ******************
    **********************************************************/
   
   /* ***************** Actions Events ******************** */

    this.editPasswordEventSave = function () {
        var editPasswordWidget = getEditPasswordWidget();
        if (editPasswordWidget.isValid()) {
            var password = editPasswordWidget.currentRow.PASSWORD;
            var newPassword = editPasswordWidget.currentRow.NEW_PASSWORD;
            var confirmPassword = editPasswordWidget.currentRow.CONFIRM_PASSWORD;
            if (ACLUtilities.validateNewPassword(newPassword, confirmPassword, password)) {
                MyProfileService.changePassword(editPasswordWidget.currentRow).then(function(){
                    editPasswordWidget.currentRow = {};
                    ScreenService.closePopup();
                    ScreenService.showMessage(AclMessages.SUC_SAVE_PASSWORD);
                }).catch(LibUtilities.showErrorMessage);
            }
        }
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register('MyProfileController', MyProfileController);
});